'use strict';

/**
 * Gives same value.
 * @param v a value
 * @returns v
 */
function id(v) {
    return v;
}

function someBool(x) {
    for (var i = 0, I = x.length; i < I; i++)
        if (x[i])
            return true;
    return false;
}
/**
 * Checks if any value satisfies a test.
 * @param x an array
 * @param ft test function (v, i, x)
 */
function some(x, ft = null) {
    if (ft)
        return x.some(ft);
    else
        return someBool(x);
}

/**
 * Combines values from arrays.
 * @param xs arrays
 * @param fm map function (vs, i)
 * @param ft till function (dones) (some)
 * @param vd default value
 */
function zip(xs, fm = null, ft = null, vd) {
    var fm = fm || id, ft = ft || some;
    var X = xs.length, a = [];
    if (X === 0)
        return a;
    var ds = new Array(X).fill(false);
    var ls = xs.map(x => x.length);
    for (var i = 0;; i++) {
        for (var j = 0, vs = []; j < X; j++) {
            ds[j] = i >= ls[j];
            vs[j] = ds[j] ? vd : xs[j][i];
        }
        if (ft(ds))
            break;
        a.push(fm(vs, i, null));
    }
    return a;
}

module.exports = zip;
